#include	"..\DLL\d_iNES.h"

static	struct
{
	u8 IRQenabled;
	u16 IRQcounter;
}	Mapper;

static	void	HBlank (int Scanline, int Byte2001)
{
	if (Mapper.IRQenabled)
	{
		Mapper.IRQcounter += 341;	/* (113 + 2/3) * 3 */
		if (Mapper.IRQcounter >= 12288)	/* 4096 * 3 */
		{
			Mapper.IRQcounter = 0;
			MP->IRQ();
		}
	}
}

static	void	PRG_Write_89 (int Bank, int Where, int What)
{
	Mapper.IRQenabled = 0;
	Mapper.IRQcounter = 0;
}

static	void	PRG_Write_AB (int Bank, int Where, int What)
{
	Mapper.IRQenabled = 1;
}

static	void	PRG_Write_EF (int Bank, int Where, int What)
{
	MP->SetPRG_ROM8(0xC,What);
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;

	MP->SetWriteHandler(0x8,PRG_Write_89);
	MP->SetWriteHandler(0x9,PRG_Write_89);
	MP->SetWriteHandler(0xA,PRG_Write_AB);
	MP->SetWriteHandler(0xB,PRG_Write_AB);
	MP->SetWriteHandler(0xE,PRG_Write_EF);
	MP->SetWriteHandler(0xF,PRG_Write_EF);

	MP->SetPRG_ROM8(0x6,6);
	MP->SetPRG_ROM32(0x8,-1);
	MP->SetCHR_RAM8(0,0);

	iNES_InitROM();
}

const	TMapperInfo	MapperInfo_040 =
{
	"SMB2j Pirate",
	40,
	MS_Full,
	8192,
	InitMapper,
	UnloadMapper,
	HBlank,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};