#include	"..\DLL\d_iNES.h"

static	struct
{
	u8 CHRbits;
	u8 Reg2enabled;
}	Mapper;

static	void	SaveMI (Ar128 MI)
{
	u8 x = 0;
	MI[x++] = Mapper.Reg2enabled;
	MI[x++] = Mapper.CHRbits;
}

static	void	LoadMI (const Ar128 MI)
{
	u8 x = 0;
	Mapper.Reg2enabled	= MI[x++];
	Mapper.CHRbits		= MI[x++];
}

static	void	PRG_Write_6 (int Bank, int Where, int What)
{
	if (Where & 0x20)
		MP->Mirror_H();
	else	MP->Mirror_V();
	Mapper.Reg2enabled = (Where & 4);
	Mapper.CHRbits = (Where >> 1) & 0xC;
	MP->SetPRG_ROM32(0x8,Where & 0x7);
}

static	void	PRG_Write_89ABCDEF (int Bank, int Where, int What)
{
	if (Mapper.Reg2enabled)
		MP->SetCHR_ROM8(0,(What & 3) | Mapper.CHRbits);
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	u8 x;

	MP = _MP;

	MP->SetWriteHandler(0x6,PRG_Write_6);

	for (x = 0x8; x <= 0xF; x++)
		MP->SetWriteHandler(x,PRG_Write_89ABCDEF);

	MP->SetPRG_ROM32(0x8,0);
	MP->SetCHR_ROM8(0,0);

	iNES_InitROM();

	Mapper.Reg2enabled = 0;
	Mapper.CHRbits = 0;
}

const	TMapperInfo	MapperInfo_041 =
{
	"Caltron 6-in-1",
	41,
	MS_Full,
	32768,
	InitMapper,
	UnloadMapper,
	NULL,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};