#include	"..\DLL\d_iNES.h"

static	struct
{
	u8 IRQenabled;
	u32 IRQcounter;
}	Mapper;

static	void	HBlank (int Scanline, int Byte2001)
{
	if (Mapper.IRQenabled)
	{
		Mapper.IRQcounter += 341;		/* (113 + 2/3) * 3 */
		if (Mapper.IRQcounter >= 73728)	/* 24576 * 3 */
			MP->IRQ();
	}
}

static	void	PRG_Write_EF (int Bank, int Where, int What)
{
	switch (Where & 0x3)
	{
	case 0:	MP->SetPRG_ROM8(0x6,What & 0x0F);	break;
	case 1:	if (What & 0x08) MP->Mirror_H();
		else MP->Mirror_V();			break;
	case 2:	if (What & 0x02)
			Mapper.IRQenabled = 1;
		else
		{
			Mapper.IRQenabled = 0;
			Mapper.IRQcounter = 0;
		}					break;
	case 3:						break;
	}
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;

	MP->SetWriteHandler(0xE,PRG_Write_EF);
	MP->SetWriteHandler(0xF,PRG_Write_EF);

	MP->SetPRG_ROM32(0x8,-1);
	MP->SetCHR_RAM8(0,0);

	iNES_InitROM();

	Mapper.IRQenabled = 0;
	Mapper.IRQcounter = 0;
}

const	TMapperInfo	MapperInfo_042 =
{
	"Mario Baby",
	42,
	MS_Full,
	8192,
	InitMapper,
	UnloadMapper,
	HBlank,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};