#include	"..\DLL\d_iNES.h"

static	struct
{
	u8 GameBanks, CurBanks;
}	Mapper;

static	void	SyncPRGCHR (void)
{
	MP->SetPRG_ROM32(0x8,((Mapper.GameBanks & 0x0F) << 1) | (Mapper.CurBanks & 0x01));
	MP->SetCHR_ROM8(0,((Mapper.GameBanks & 0xF0) >> 1) | ((Mapper.CurBanks & 0x70) >> 4));
}

static	void	SaveMI (Ar128 MI)
{
	u8 x = 0;
	MI[x++] = Mapper.GameBanks;
	MI[x++] = Mapper.CurBanks;
}

static	void	LoadMI (const Ar128 MI)
{
	u8 x = 0;
	Mapper.GameBanks	= MI[x++];
	Mapper.CurBanks	= MI[x++];
}

static	void	PRG_Write_67 (int Bank, int Where, int What)
{
	Mapper.GameBanks = What;
	SyncPRGCHR();
}

static	void	PRG_Write_89ABCDEF (int Bank, int Where, int What)
{
	Mapper.CurBanks = What;
	SyncPRGCHR();
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	u8 x;

	MP = _MP;

	for (x = 0x6; x < 0x8; x++)
		MP->SetWriteHandler(x,PRG_Write_67);

	for (x = 0x8; x <= 0xF; x++)
		MP->SetWriteHandler(x,PRG_Write_89ABCDEF);

	Mapper.GameBanks = Mapper.CurBanks = 0;

	SyncPRGCHR();

	iNES_InitROM();
}

const	TMapperInfo	MapperInfo_046 =
{
	"GameStation/RumbleStation",
	46,
	MS_Full,
	32768,
	InitMapper,
	UnloadMapper,
	NULL,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};
