#include	"..\DLL\d_iNES.h"

static	struct
{
	PWriteFunc PRG_Write_4;
	u8 IRQenabled;
	u16 IRQcounter;
}	Mapper;

static	void	HBlank (int Scanline, int Byte2001)
{
	if (Mapper.IRQenabled)
	{
		Mapper.IRQcounter += 341;	/* (113 + 2/3) * 3 */
		if (Mapper.IRQcounter >= 12288)	/* 4096 * 3 */
		{
			Mapper.IRQcounter = 0;
			MP->IRQ();
		}
	}
}

static	void	PRG_Write_45 (int Bank, int Where, int What)
{
	if (Bank == 4)
		Mapper.PRG_Write_4(Bank,Where,What);
	if ((Where & 0x060) != 0x020)
		return;
	if (Where & 0x100)
	{
		if (What & 1)
			Mapper.IRQenabled = 1;
		else
		{
			Mapper.IRQcounter = 0;
			Mapper.IRQenabled = 0;
		}
	}
	else
		MP->SetPRG_ROM8(0xC,((What & 0x1) << 2) | ((What & 0x6) >> 1) | (What & 0x8));
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;

	Mapper.PRG_Write_4 = MP->GetWriteHandler(0x4);

	MP->SetWriteHandler(0x4,PRG_Write_45);
	MP->SetWriteHandler(0x5,PRG_Write_45);

	MP->SetPRG_ROM8(0x6,0xF);
	MP->SetPRG_ROM8(0x8,0x8);
	MP->SetPRG_ROM8(0xA,0x9);
	MP->SetPRG_ROM8(0xC,0xA);	/* random */
	MP->SetPRG_ROM8(0xE,0xB);

	MP->SetCHR_RAM8(0,0);

	iNES_InitROM();
}

const	TMapperInfo	MapperInfo_050 =
{
	"Another SMB2j pirate",
	50,
	MS_Full,
	8192,
	InitMapper,
	UnloadMapper,
	HBlank,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};
