#include	"..\DLL\d_iNES.h"
#include	"..\Hardware\h_MMC3.h"

static	void	Sync (void)
{
	u8 x, SwCHR = (MMC3.Cmd & 0x80) >> 5;

	MMC3_SyncMirror();
	MMC3_SyncPRG(0x3F,0);

	for (x = 0; x < 8; x++)
	{
		if (MMC3.CHR[x] & 0x40)
			MP->SetCHR_RAM1(SwCHR ^ x,MMC3.CHR[x] & 0x07);
		else	MP->SetCHR_ROM1(SwCHR ^ x,MMC3.CHR[x]);
	}
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;

	iNES_InitROM();
	MMC3_Init(Sync);
}

const	TMapperInfo	MapperInfo_119 =
{
	"TQROM (MMC3)",
	119,
	MS_Full,
	8192,
	InitMapper,
	UnloadMapper,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};